## org.aspectj.weaver.tools
Interface ContextBasedMatcher

    public interface ContextBasedMatcher

Pointcut expression interface for pointcut expressions returned by a PointcutDesignatorHandler. Provides an additional matching method for matching based on context information over and above that normally used by AspectJ.

See Also:
  `MatchingContext`

Method Summary
`boolean` `couldMatchJoinPointsInType(java.lang.Class aClass)` Deprecated. use couldMatchJoinPointsInType(Class,MatchingContext) instead
`boolean` `couldMatchJoinPointsInType(java.lang.Class aClass, MatchingContext matchContext)` return true iff this matcher could ever match a join point in the given type, may also use any match context information available
`boolean` `matchesDynamically(MatchingContext matchContext)` Called during processing of ShadowMatch.matchesJoinPoint when matchesStatically returned FuzzyBoolean.MAYBE.
`FuzzyBoolean` `matchesStatically(MatchingContext matchContext)` Return FuzzyBoolean.YES if a join point with the given matching context is always matched.
`boolean` `mayNeedDynamicTest()` return true if matchesStatically can ever return FuzzyBoolean.MAYBE (necessitating a per-join point test to determine matching at a given join point).

Method Detail

### couldMatchJoinPointsInType

    boolean couldMatchJoinPointsInType(java.lang.Class aClass)

  Deprecated. use couldMatchJoinPointsInType(Class,MatchingContext) instead

  return true iff this matcher could ever match a join point in the given type

### couldMatchJoinPointsInType

    boolean couldMatchJoinPointsInType(java.lang.Class aClass,
                                       MatchingContext matchContext)

  return true iff this matcher could ever match a join point in the given type, may also use any match context information available

  Since:
    1.5.1

### mayNeedDynamicTest

    boolean mayNeedDynamicTest()

  return true if matchesStatically can ever return FuzzyBoolean.MAYBE (necessitating a per-join point test to determine matching at a given join point).

### matchesStatically

    FuzzyBoolean matchesStatically(MatchingContext matchContext)

  Return FuzzyBoolean.YES if a join point with the given matching context is always matched. Return FuzzyBoolean.NO if a join point with the given matching context is never matched. Return FuzzyBoolean.MAYBE if a match cannot be determined statically (whilst generating a ShadowMatch), and must be determined on a per-join point basis.

### matchesDynamically

    boolean matchesDynamically(MatchingContext matchContext)

  Called during processing of ShadowMatch.matchesJoinPoint when matchesStatically returned FuzzyBoolean.MAYBE.